<template>
    <div class="carousel">
        <div class="inner" ref="inner" :style="innerStyles">
            <div class="card" v-for="card in cards" :key="card">
                <img src="https://c8.alamy.com/comp/F925E4/businessman-committing-suicide-through-hanging-F925E4.jpg" @load="setStep()">
                <h3>
                    {{ card.name }}
                </h3>
                <div>
                </div>
            </div>
        </div>
        <button class="btnNext" @click="next">
            <svg fill="#000000" width="60px" height="60px" viewBox="0 0 1024 1024" xmlns="http://www.w3.org/2000/svg" stroke="white">
                <path fill="black" d="M419.3 264.8l-61.8 61.8L542.9 512 357.5 697.4l61.8 61.8L666.5 512z"/>
            </svg>
        </button>
    </div>
</template>

<script>
import apiCalls from '@/services/apiCalls.service'

export default {
    data() {
        return {
            cards: [],
            innerStyles: {},
            step: "",
            transitioning: false,
            timeout: 0
        }
    },
    mounted() {
        this.getFutureCons()
        setInterval(this.autoScroll, 1000)
    },
    methods: {
        getFutureCons(){
            apiCalls.get('api/v1/conventions')
                .then(res => {
                    this.cards = res
                })
        },
        setStep() {
            let innerWidth = this.$refs.inner.scrollWidth
            let totalCards = this.cards.length
            this.step = `${innerWidth / totalCards}px`
        },
        next() {
            if (this.transitioning) return
            this.transitioning = true
            this.moveLeft()
            this.afterTransition(() => {
                let card = this.cards.shift()
                this.cards.push(card)
                this.resetTranslate()
                this.transitioning = false
            })
        },
        prev() {
            if (this.transitioning) return
            this.transitioning = true
            this.moveRight()
            this.afterTransition(() => {
                let card = this.cards.pop()
                this.cards.unshift(card)
                this.resetTranslate()
                this.transitioning = false
            })
        },
        moveLeft() {
            this.innerStyles = {
                transform: `translateX(-${this.step})
                            translateX(-${this.step})`
            }
        },
        moveRight() {
            this.innerStyles = {
                transform: `translateX(${this.step})
                            translateX(-${this.step})`
            }
        },
        afterTransition(callback) {
            const listener = () => {
                callback()
                this.$refs.inner.removeEventListener('transitionend', listener)
            }
            this.$refs.inner.addEventListener('transitionend', listener)
        },
        resetTranslate() {
            this.innerStyles = {
                transition: 'none',
                transform: `translateX(-${this.step})`
            }
        },
        autoScroll() {
            if (this.timeout > 6){
                this.next()
                this.timeout = 0
            } else {
                this.timeout++
            }
        }
    }
}
</script>

<style scoped>
.carousel {
    position: relative;
    max-width: 100%;
    overflow: hidden;
    box-shadow: 0 0 15px rgb(87, 82, 82);
    border-radius: 5px;
    margin: 1rem 0.5rem;
}

.inner {
  white-space: nowrap;
  transition: transform 0.2s;
}

.card {
    width: 21%;
    margin: 5px;
    padding: 18px 12px 12px 12px;
    display: inline-flex;
    flex-direction: column;
    height: 20vh;
    color: black;
    border-radius: 4px;
    align-items: center;
    justify-content: center;
    max-width: 100%;
    overflow: hidden;
}

.cardInsides {
    position: relative;
    width: 100%;
    height: auto;
    margin: 0.5vw;
}
.card img {
    width: 100%;
    height: auto;
    max-height: 80%;
    object-fit: cover;
    border-radius: 20px;
    margin: 4px;
    border: 3px orange solid;
}

.carousel button {
    z-index: 99;
    position: absolute;
    top: 50%;
}
.carousel button {
    z-index: 1;
    position: absolute;
    top: 25%;
    background: none;
    border: none;
    right: 0;
    margin: 0;
    padding: 0;
    border-radius: 50%;
}
/* .carousel button:hover {
    transition: 0.3s ease-in;
    background: rgba(0, 0, 0, 0.5);
    box-shadow: inset 10px 0 50px rgba(0, 0, 0, 0.5);
    border-radius: 50%;
    border: none;
} */
</style>

